<?php
/*
  Plugin Name: Pactic.hu integráció
  Plugin URI: https://pactic.hu/
  Description: Pactic.hu integrálása WooCommerce-hez.
  Version: 2.0
  Author: Fürgefutár.hu
  Author URI:  https://pactic.hu/
  Text Domain: furgefutar
  Domain Path: /languages
*/
 

/**********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/

define( 'FURGEFUTAR_PLUGIN_DIR_URL', plugin_dir_url( __FILE__ ) );
define( 'FURGEFUTAR_PLUGIN_DIR_PATH', plugin_dir_path( __FILE__ ) );

/**********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/

require_once( 'includes/furgefutar.php' );
require_once( 'includes/csomagpont.php' );

/**********************************************************************************************************************************************************************/
/*********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/

add_action( 'plugins_loaded', 'furgefutar_forditas', 0 );

function furgefutar_forditas() {
    
    $locale = apply_filters( 'plugin_locale', get_locale(), 'furgefutar' );

	load_textdomain( 'furgefutar', WP_LANG_DIR . '/plugins/furgefutar-' . $locale . '.mo' );
	load_plugin_textdomain( 'furgefutar', false, plugin_basename( dirname( __FILE__ ) ) . '/languages' );
    
}

/**********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/

add_action( 'admin_enqueue_scripts', 'furgefutar_admin_css_js' );

function furgefutar_admin_css_js() {
    
    wp_enqueue_script( 'furgefutar_admin_js', FURGEFUTAR_PLUGIN_DIR_URL.'js/admin.js', array('jquery'), filemtime( FURGEFUTAR_PLUGIN_DIR_PATH.'js/admin.js' ), false );
    
    wp_enqueue_style( 'Dosis-google-fonts', 'https://fonts.googleapis.com/css?family=Dosis:400,700,800&amp;subset=latin-ext', false ); 
    
    $furgefutar_admin_adatok = array( 
        'ajax_url' => admin_url( 'admin-ajax.php' ),
        'plugin_dir_url' => FURGEFUTAR_PLUGIN_DIR_URL,
        'nincs_kivalasztott_csomagpont' => __( 'még nincs kiválasztva', 'furgefutar' ),
    );
    
    wp_localize_script( 'furgefutar_admin_js', 'furgefutar_admin_adatok', $furgefutar_admin_adatok );
    
    wp_enqueue_style( 'furgefutar_admin_css', FURGEFUTAR_PLUGIN_DIR_URL.'css/admin.css', '', filemtime( FURGEFUTAR_PLUGIN_DIR_PATH.'css/admin.css' ), 'all' );
    
}

/**********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/

add_action( 'wp_enqueue_scripts', 'furgefutar_frontend_css_js' );

function furgefutar_frontend_css_js() {
    
    wp_enqueue_script( 'furgefutar_frontend_js', FURGEFUTAR_PLUGIN_DIR_URL.'js/frontend.js', array('jquery'), filemtime( FURGEFUTAR_PLUGIN_DIR_PATH.'js/frontend.js' ), false );
    
    $furgefutar_frontend_adatok = array( 
        'ajax_url' => admin_url( 'admin-ajax.php' ),
        'plugin_dir_url' => FURGEFUTAR_PLUGIN_DIR_URL,
        'csomagpont_cim' => __( 'GLS CsomagPont választó', 'furgefutar' ),
        'kivalasztott_csomagpont' => __( 'Választott GLS CsomagPont:', 'furgefutar' ),
        'csomagpont_kereses' => __( 'Keresés irányítószám alapján', 'furgefutar' ),
        'nincs_kivalasztott_csomagpont' => __( 'még nincs kiválasztva', 'furgefutar' ),
        'kosar_csomagpont_valasztas' => __( 'A csomagpont kiválasztása a következő lépésben történik.', 'furgefutar' ),
    );
    
    wp_localize_script( 'furgefutar_frontend_js', 'furgefutar_frontend_adatok', $furgefutar_frontend_adatok );
    
    wp_enqueue_script( 'furgefutar_gmap', 'https://maps.googleapis.com/maps/api/js?key='.get_option( 'furgefutar_gls_csomagpont_api_kulcs' ) );

    wp_enqueue_script( 'furgefutar_gmap_markerclusterer', 'https://developers.google.com/maps/documentation/javascript/examples/markerclusterer/markerclusterer.js' );

    wp_enqueue_style( 'furgefutar_frontend_css', FURGEFUTAR_PLUGIN_DIR_URL.'css/frontend.css', '', filemtime( FURGEFUTAR_PLUGIN_DIR_PATH.'css/frontend.css' ), 'all' );


}

/**********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/

?>