<?php

register_activation_hook( __FILE__, 'furgefutar_mappa' );

function furgefutar_mappa(){
    
    $upload_dir = wp_upload_dir();

    if (!is_dir( $upload_dir['basedir'].'/furgefutar' )) {
        
        mkdir( $upload_dir['basedir'].'/furgefutar', 0777, true );
        
    }
    
}

/**********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/

add_filter('manage_edit-shop_order_columns' , 'furgefutar_order_column_title', 10);
 
function furgefutar_order_column_title( $columns ) {

    if(  get_option( 'furgefutar_allapot' ) == 'yes' ){

        $columns['furgefutar'] = '<span><img src="'.FURGEFUTAR_PLUGIN_DIR_URL.'images/pactic_ikon_2.png"></span>';  
    
    }
    
    return $columns;
    
}

/**********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/

add_action('manage_shop_order_posts_custom_column' , 'furgefutar_order_column', 10, 2 );
 
function furgefutar_order_column( $column_name, $order_id ) {
    
    if(  get_option( 'furgefutar_allapot' ) == 'yes' ){
    
        switch ( $column_name ) {
            case 'furgefutar' :
            
                furgefutar_gombok( $order_id );

                break;
                
        }
    
    }
    
}

/**********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/

function furgefutar_gombok( $order_id, $string = false ){
    
    $kimenet = '';
    
    $upload_dir = wp_upload_dir();
                
    $furgefutar_azonosito = get_post_meta( $order_id, '_furgefutar_azonosito', true );
    $furgefutar_fuvarlevelszam = get_post_meta( $order_id, '_furgefutar_fuvarlevelszam', true );
    
    $kimenet .= '<div class="furgefutar_megrendeles_gomb_box_'.$order_id.'">';
    
    if( empty( $furgefutar_azonosito ) && empty( $furgefutar_fuvarlevelszam ) ){

        $kimenet .= '<a class="button furgefutar_megrendeles_gomb" order_id="'.$order_id.'" >'.__( 'Megrendelés', 'furgefutar' ).'</a>';
         
    }
    else if( !empty( $furgefutar_azonosito ) && empty( $furgefutar_fuvarlevelszam ) ){

        $kimenet .= '<a class="button furgefutar_megrendeles_gomb furgefutar_ujrarendeles_gomb" order_id="'.$order_id.'" >'.__( 'Újrarendelés', 'furgefutar' ).'</a>';

        $kimenet .= '<p><strong>'.__( 'Rendelési azonosító:', 'furgefutar' ).'</strong> '.$furgefutar_azonosito.'</p>';
        
        $kimenet .= '<p><br/>'.__( 'A fuvarlevelet a Pactic ügyfélszolgálata küldi el Önnek.', 'furgefutar' ).'</p>';

    }
    else if( !empty( $furgefutar_azonosito ) && !empty( $furgefutar_fuvarlevelszam ) ){
        
        $kimenet .= '<a class="button furgefutar_megrendeles_gomb furgefutar_ujrarendeles_gomb" order_id="'.$order_id.'" >'.__( 'Újrarendelés', 'furgefutar' ).'</a>';
    
     
        $kimenet .= '<p><strong>'.__( 'Rendelési azonosító:', 'furgefutar' ).'</strong> '.$furgefutar_azonosito.'</p>';
        
        $kimenet .= '<p>';
            
            $kimenet .= '<span><strong>'.__( 'Fuvarlevélszám:', 'furgefutar' ).'</strong> '.$furgefutar_fuvarlevelszam.'</span>';
                       
            if( file_exists( $upload_dir['basedir'].'/furgefutar/fuvarlevel_'.$order_id.'_'.$furgefutar_fuvarlevelszam.'.pdf' ) ){
                
                $kimenet .= '<a target="_blank" class="button button-secondary furgefutar_gomb furgefutar_fuvarlevel_gomb" title="'.__( 'Megtekintés', 'furgefutar' ).'" href="'.$upload_dir['baseurl'].'/furgefutar/fuvarlevel_'.$order_id.'_'.$furgefutar_fuvarlevelszam.'.pdf'.'"></a>';
            
            }

        $kimenet .= '</p>';
        
        if( $csomag_statusz = furgefutar_csomag_statusz( $furgefutar_fuvarlevelszam ) ){
 
            $kimenet .= '<p><strong>'.__( 'Csomag státusz:', 'furgefutar' ).'</strong> <a href="'.get_edit_post_link( $order_id ).'#furgefutar_tracking_meta_box" title="'.$csomag_statusz['leiras'].'">'.$csomag_statusz['nev'].'</a></p>';
            
        
        }
        else if( $nyomkovetes_url = furgefutar_nyomkovetes_url( $furgefutar_fuvarlevelszam ) ){
            
            $kimenet .= '<a target="_blank" class="button button-secondary furgefutar_gomb furgefutar_nyomkovetes_gomb" title="'.__( 'Nyomkövetés', 'furgefutar' ).'" href="'.$nyomkovetes_url.'"></a>';
       
        }

    }
    
    $kimenet .= '</div>';
    
    if( $string == true ){
        return $kimenet;
    }
    else{
        echo $kimenet;
    }

}

/**********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/

function furgefutar_nyomkovetes_url( $furgefutar_fuvarlevelszam ){
    
    if( strlen( $furgefutar_fuvarlevelszam ) == 11 && substr( $furgefutar_fuvarlevelszam, 0, 3) == '002' ){
        
        $nyelv_kod = furgefutar_nyelv();
        
        if( $nyelv_kod == 'HU' ){
            return 'https://gls-group.eu/HU/hu/csomagkovetes?match='.$furgefutar_fuvarlevelszam;
        }
        else{
            return 'https://gls-group.eu/HU/en/parcel-tracking?match='.$furgefutar_fuvarlevelszam;
        }
        
        
    }
    else if( strlen( $furgefutar_fuvarlevelszam ) == 14 && substr( $furgefutar_fuvarlevelszam, 0, 3) == '164' ){
        
        $nyelv_kod = furgefutar_nyelv();
        
        if( $nyelv_kod == 'HU' ){
            return 'https://tracking.dpd.de/parcelstatus?query='.$furgefutar_fuvarlevelszam.'&locale=hu_HU';
        }
        else{
            return 'https://tracking.dpd.de/parcelstatus?query='.$furgefutar_fuvarlevelszam.'&locale=en_HU';
        }
        
        
    }
    else{
        return false;
    }
    
}


/**********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/

add_action("add_meta_boxes", "furgefutar_order_meta_box");

function furgefutar_order_meta_box(){
    
    if(  get_option( 'furgefutar_allapot' ) == 'yes' ){

        add_meta_box("furgefutar_meta_box", '<div class="furgefutar_order_meta_box_fejlec"><img src="'.FURGEFUTAR_PLUGIN_DIR_URL.'images/pactic_ikon_2.png" /></div>', 'furgefutar_order_meta_box_content', 'shop_order', 'side', 'high', null);

        add_meta_box("furgefutar_tracking_meta_box", '<div class="furgefutar_order_meta_box_fejlec"><img src="'.FURGEFUTAR_PLUGIN_DIR_URL.'images/pactic_ikon_2.png" /><span>'.__( 'Nyomkövetés', 'furgefutar' ).'</span></div>', 'furgefutar_order_tracking_meta_box_content', 'shop_order', 'side', 'high', null);

    }
    
}


/**********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/

function furgefutar_order_meta_box_content( $order ){
    
    if(  get_option( 'furgefutar_allapot' ) == 'yes' ){

        if( !empty( $order->ID ) ){

            furgefutar_gombok( $order->ID );
            
        }
    
    }
    
}

/**********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/

function furgefutar_order_tracking_meta_box_content( $order ){
    
    if(  get_option( 'furgefutar_allapot' ) == 'yes' ){

        if( !empty( $order->ID ) ){
            
            $furgefutar_fuvarlevelszam = get_post_meta( $order->ID, '_furgefutar_fuvarlevelszam', true );

            $csomag_statuszok = furgefutar_csomag_statusz( $furgefutar_fuvarlevelszam, true );
            
            if( $csomag_statuszok ){
                
                echo '<div class="furgefutar_tracking_tablazat">';
                
                    foreach( $csomag_statuszok as $csomag_statusz ){
                        
                        echo '<div class="furgefutar_tracking_tablazat_sor">';
                        
                            echo '<div class="furgefutar_tracking_tablazat_sor_cella furgefutar_tracking_tablazat_sor_cella_datum">';

                                echo implode("<br/>", explode(" ", $csomag_statusz['datum'] ) );
                            
                            echo '</div>';
                            
                            echo '<div class="furgefutar_tracking_tablazat_sor_cella furgefutar_tracking_tablazat_sor_cella_nev" title="'.$csomag_statusz['leiras'].'">';
                        
                                echo $csomag_statusz['nev'].'<br/>';
                            
                            echo '</div>';
                            
                            echo '<div class="furgefutar_tracking_tablazat_sor_cella furgefutar_tracking_tablazat_sor_cella_ikon">';

                                if( file_exists( FURGEFUTAR_PLUGIN_DIR_PATH.'/images/csomag_statusz_'.$csomag_statusz['id'].'.png' ) ){
                                    
                                    echo '<img src="'.FURGEFUTAR_PLUGIN_DIR_URL.'/images/csomag_statusz_'.$csomag_statusz['id'].'.png" title="'.$csomag_statusz['leiras'].'" />';
                                    
                                }

                            echo '</div>';
                        
                        echo '</div>';
                        
                    }
                    
                echo '</div>';
                
            }
            
        }
    
    }
    
}

/**********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/

function furgefutar_konvertalas( $string ){
    
    if( $string == 'yes'  ){
        return 'true';
    }
    else{
        return 'false';
    }
    
}

/**********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/


function furgefutar_nyelv(){
    
    $locale = get_locale();
    
    if( $locale && substr( $locale, 0, 2 ) == 'hu' ){
        return 'HU';
    }
    else if( $locale && substr( $locale, 0, 2 ) == 'en' ){
        return 'EN';
    }
    else{
        return 'EN';
    }
    
}

/**********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/

add_filter( 'woocommerce_settings_tabs_array', 'furgefutar_add_settings_tab', 50 );

function furgefutar_add_settings_tab( $settings_tabs ) {
    
    $settings_tabs['furgefutar'] = 'Pactic';
    
    return $settings_tabs;
    
}

/**********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/

add_action( 'woocommerce_settings_tabs_furgefutar', 'furgefutar_settings_tab' );

function furgefutar_settings_tab() {
    
    echo '<table class="form-table">';
    
        woocommerce_admin_fields( furgefutar_get_settings() );
        
    echo '</table>';
    
}

/**********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/

add_filter( 'plugin_action_links_' . plugin_basename(__FILE__), 'furgefutar_action_links' );

function furgefutar_action_links( $links ) {
    
   $links[] = '<a href="'. esc_url( get_admin_url(null, 'admin.php?page=wc-settings&tab=furgefutar') ) .'">'.__( 'Beállítások', 'furgefutar' ).'</a>';

   return $links;
   
}


/**********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/

add_action( 'woocommerce_update_options_furgefutar', 'furgefutar_update_settings' );

function furgefutar_update_settings() {
    
    woocommerce_update_options( furgefutar_get_settings() );
    
}

/**********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/

function furgefutar_get_settings() {

    $settings = array(
        'furgefutar_section_1' => array(
            'name'     => __( 'Álatalános beállítások', 'furgefutar' ),
            'type'     => 'title',
        ),
        'furgefutar_allapot' => array(
            'title'   => __( 'Bekapcsolás / Kikapcsolás', 'furgefutar' ),
            'type'    => 'checkbox',
            'default' => 'no',
            'desc' => __( 'Pactic engedélyezése', 'furgefutar' ),
            'desc_tip'    => true,
            'id'      => 'furgefutar_allapot'
        ),
        'furgefutar_tesztkornyezet' => array(
            'title'       => __( 'Tesztkörnyezet', 'furgefutar' ),
            'type'        => 'checkbox',
            'default'     => 'yes',
            'desc' => __( 'Tesztkörnyezet használata', 'furgefutar' ),
            'desc_tip'    => true,
            'id'      => 'furgefutar_tesztkornyezet'
        ),
        'furgefutar_debug' => array(
            'title'       => __( 'Debug mód', 'furgefutar' ),
            'type'        => 'checkbox',
            'default'     => 'no',
            'desc' => __( 'A Pactic rendszerének küldött kérés és a rá kapott válasz is megjelenik.', 'furgefutar' ),
            'desc_tip'    => true,
            'id'      => 'furgefutar_debug'
        ),
        'furgefutar_fizetesi_modok' => array(
            'title'       => __( 'További utánvétes fizetési módok', 'furgefutar' ),
            'type'        => 'multiselect',
            //'default'     => 'cod',
            'options'     => furgefutar_engedelyezett_fizetesi_modok(),
            'desc'        => __( 'A bővítmény automatikusan kiválasztja az alapértelmezett utánvétes fizetési módot:', 'furgefutar' ).' <strong>'.furgefutar_engedelyezett_fizetesi_modok( 'cod' ).'</strong>.'.
                             '<br/>'.__( 'Amennyiben webáruházában további fizetési módok is utánvétesnek számítanak, úgy itt állíthatja be azokat.', 'furgefutar' ),
            'id'      => 'furgefutar_fizetesi_modok',
        ),
        'furgefutar_section_1_end' => array(
             'type' => 'sectionend'
        ),
        
        
        'furgefutar_section_2' => array(
            'name'     => __( 'Pactic fiók adatok', 'furgefutar' ),
            'type'     => 'title',
            'desc'     => '',
        ),
        'furgefutar_email' => array(
            'name' => __( 'E-mail cím', 'furgefutar' ),
            'type' => 'text',
            'desc' => __( 'A Pactic rendszerében megadott e-mail cím', 'furgefutar' ),
            'desc_tip'    => true,
            'id'   => 'furgefutar_email',
            'placeholder' => __( 'valami@valami.hu', 'furgefutar' ),
            'class' => 'input_width_30'
        ),
        'furgefutar_jelszo' => array(
            'name' => __( 'Jelszó', 'furgefutar' ),
            'type' => 'text',
            'desc' => __( 'A Pactic rendszerében megadott jelszó', 'furgefutar' ),
            'desc_tip'    => true,
            'id'   => 'furgefutar_jelszo',
            'class' => 'input_width_30'
        ),
        'furgefutar_section_2_end' => array(
             'type' => 'sectionend'
        ),
        
        
        'furgefutar_section_3' => array(
            'name'     => __( 'Pactic felhasználási feltételek', 'furgefutar' ),
            'type'     => 'title',
            'desc'     => '',
        ),
        'furgefutar_tiltott_aru' => array(
            'title'   => __( 'Elismerem, hogy nem küldök semmilyen tiltott árut.', 'furgefutar' ),
            'type'    => 'checkbox',
            'default' => 'no',
            'desc' => __( 'Tiltott áruk listája megtalálható a Pactic oldalon:', 'furgefutar' ).
                '<a target="_blank" href="https://furgefutar.hu/nem-szallithato-targyak">https://furgefutar.hu/nem-szallithato-targyak</a>,  
                <a target="_blank" href="https://furgefutar.hu/hasznos-tudnivalok/mi-tartozik-veszelyes-es-tiltott-aru-kategoriaba/">https://furgefutar.hu/hasznos-tudnivalok/mi-tartozik-veszelyes-es-tiltott-aru-kategoriaba/</a>',
            'desc_tip'    => true,
            'id'      => 'furgefutar_tiltott_aru'
        ),
        'furgefutar_aszf' => array(
            'title'   => __( 'Elismerem, hogy elolvastam a Pactic Általános Felhasználói Szerződését.', 'furgefutar' ),
            'type'    => 'checkbox',
            'default' => 'no',
            'desc' => __( 'Az Általános Felhasználói Szerződés megtalálható a Pactic oldalon:', 'furgefutar' ).' <a target="_blank" href="https://furgefutar.hu/aszf">https://furgefutar.hu/aszf</a>',
            'desc_tip'    => true,
            'id'      => 'furgefutar_aszf'
        ),
        'furgefutar_section_3_end' => array(
             'type' => 'sectionend'
        ),

        'furgefutar_section_4' => array(
            'name'     => __( 'Feladási adatok', 'furgefutar' ),
            'type'     => 'title',
            'desc'     => __( 'Amennyiben a Pactic oldalán a Beállításokban már megadta a következő adatokat, itt már nem kötelező megadni!', 'furgefutar' ),
        ),
        'furgefutar_felado_neve' => array(
            'name' => __( 'Feladó neve', 'furgefutar' ),
            'type' => 'text',
            'id'   => 'furgefutar_felado_neve',
            'placeholder' => __( 'Gipsz Jakab', 'furgefutar' ),
            'class' => 'input_width_30'
        ),
        'furgefutar_felado_bank_neve' => array(
            'name' => __( 'Feladó bankjának neve', 'furgefutar' ),
            'type' => 'text',
            'id'   => 'furgefutar_felado_bank_neve',
            'placeholder' => __( 'OTP', 'furgefutar' ),
            'class' => 'input_width_30'
        ),
        'furgefutar_felado_bankszamlaszama' => array(
            'name' => __( 'Feladó bankszámlaszáma', 'furgefutar' ),
            'type' => 'text',
            'id'   => 'furgefutar_felado_bankszamlaszama',
            'placeholder' => __( '12345678-12345678-12345678', 'furgefutar' ),
            'class' => 'input_width_30'
        ),
        'furgefutar_section_4_end' => array(
             'type' => 'sectionend'
        ),
        
        'furgefutar_section_5' => array(
            'name'     => __( 'Generált fuvarlevelek', 'furgefutar' ),
            'type'     => 'title',
            'desc'     => __( 'Amennyiben törölni szeretné az Ön által generált PDF fuvarleveleket, itt megteheti!', 'furgefutar' ).'<br/><p><a class="button furgefutar_fuvarlevelek_torles_gomb">'.__( 'Fuvarlevelek törlése', 'furgefutar' ).'</a></p>',
        ),
        'furgefutar_section_5_end' => array(
             'type' => 'sectionend'
        ),
        
        'furgefutar_section_6' => array(
            'name'     => __( 'GLS CsomagPont beállítások', 'furgefutar' ),
            'type'     => 'title',
        ),
        'furgefutar_gls_csomagpont_tipus' => array(
            'title'   => __( 'Megjelenés', 'furgefutar' ),
            'type'    => 'radio',
            'default' => 'legordulo',
            'options' => array( 'legordulo' => __( 'Legördülő', 'furgefutar' ), 'terkepes' => __( 'Térképes', 'furgefutar' ) ),
            'desc_tip'    => true,
            'id'      => 'furgefutar_gls_csomagpont_tipus'
        ),
        'furgefutar_gls_csomagpont_api_kulcs' => array(
            'title'   => __( 'Google Map Api kulcs', 'furgefutar' ),
            'type'    => 'text',
            'default' => '',
            'desc' => '<br/>'.__( 'Amennyiben a térképes megjelenést választja, szükség van Google Map Api kulcsra!', 'furgefutar' ),
            'id'      => 'furgefutar_gls_csomagpont_api_kulcs'
        ),
        'furgefutar_section_6_end' => array(
             'type' => 'sectionend'
        ),
        
    );


    return apply_filters( 'furgefutar_settings', $settings );
}    
    
/**********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/

    
function furgefutar_ajax_megrendeles() {
    
    if ( isset($_REQUEST) ) {
        
        $order_id = $_REQUEST['order_id'];
        
        $furgefutar_megrendeles_return = furgefutar_megrendeles( $order_id );
               
        echo $furgefutar_megrendeles_return;
        
   
    }
    
    die();
}

add_action( 'wp_ajax_furgefutar_ajax_megrendeles', 'furgefutar_ajax_megrendeles' );


/**********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/

function furgefutar_megrendeles_torlese( $order_id ) {
    
    $upload_dir = wp_upload_dir();
                    
    $furgefutar_azonosito = get_post_meta( $order_id, '_furgefutar_azonosito', true );
    $furgefutar_fuvarlevelszam = get_post_meta( $order_id, '_furgefutar_fuvarlevelszam', true );  
    
    if( $furgefutar_azonosito ){
    
        update_post_meta( $order_id, '_furgefutar_azonosito', '' );
        
    }
    
    if( $furgefutar_fuvarlevelszam ){
        
        update_post_meta( $order_id, '_furgefutar_fuvarlevelszam', '' );
        
        $fajlnev_dir = $upload_dir['basedir'].'/furgefutar/fuvarlevel_'.$order_id.'_'.$furgefutar_fuvarlevelszam.'.pdf';
    
        if( file_exists( $fajlnev_dir ) ){
            
            unlink( $fajlnev_dir );
    
        }
        
    }
    
}

/**********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/


function furgefutar_megrendeles( $order_id ) {
    
    furgefutar_megrendeles_torlese( $order_id );
    
    $order = wc_get_order( $order_id );

    $company = method_exists( $order, 'get_shipping_company' ) ? $order->get_shipping_company() : $order->shipping_company;
    $contact_first_name = method_exists( $order, 'get_shipping_first_name' ) ? $order->get_shipping_first_name() : $order->shipping_first_name;
    $contact_last_name = method_exists( $order, 'get_shipping_last_name' ) ? $order->get_shipping_last_name() : $order->shipping_last_name;
    
    if( !empty( $company ) ){
        $nmCompanyOrPerson = $company;
        $nmContact = $contact_last_name.' '.$contact_first_name;
    }
    else{
        $nmCompanyOrPerson = $contact_last_name.' '.$contact_first_name;
        $nmContact = $contact_last_name.' '.$contact_first_name;
    }
    
    $furgefutar_kivalasztott_gls_csomagpont_json = get_post_meta( $order_id, '_furgefutar_kivalasztott_gls_csomagpont', true );

    if( !empty( $furgefutar_kivalasztott_gls_csomagpont_json ) ) {
      
        $furgefutar_kivalasztott_gls_csomagpont = json_decode( str_replace( "'", '"', $furgefutar_kivalasztott_gls_csomagpont_json ), true );
      
        $cdDropOffPoint = (string)$furgefutar_kivalasztott_gls_csomagpont['Code'];
        
        $DESTINATIONADDRESS = array(
            'nmCompanyOrPerson' => $nmCompanyOrPerson,
            'nmContact' => $nmContact,
            'cdCountry' => method_exists( $order, 'get_shipping_country' ) ? $order->get_shipping_country() : $order->shipping_country,
            'cdDropOffPoint' => $cdDropOffPoint,
            'txAddress' => '',
            'txAddressNumber' => '.',
            'txPost' => '',
            'txCity' => '',
            'txPhoneContact' => method_exists( $order, 'get_billing_phone' ) ? $order->get_billing_phone() : $order->billing_phone,
            'txEmailContact' => method_exists( $order, 'get_billing_email' ) ? $order->get_billing_email() : $order->billing_email,
            'txInstruction' => (string)substr( ( method_exists( $order, 'get_customer_note' ) ? $order->get_customer_note() : $order->customer_note ), 0, 63 )
        );
          
    }
    else{
        
        $DESTINATIONADDRESS = array(
            'nmCompanyOrPerson' => $nmCompanyOrPerson,
            'nmContact' => $nmContact,
            'cdCountry' => method_exists( $order, 'get_shipping_country' ) ? $order->get_shipping_country() : $order->shipping_country,
            'txAddress' => method_exists( $order, 'get_shipping_address_1' ) ? $order->get_shipping_address_1() : $order->shipping_address_1,
            'txAddressNumber' => '.',
            'txPost' => method_exists( $order, 'get_shipping_postcode' ) ? $order->get_shipping_postcode() : $order->shipping_postcode,
            'txCity' => method_exists( $order, 'get_shipping_city' ) ? $order->get_shipping_city() : $order->shipping_city,
            'txPhoneContact' => method_exists( $order, 'get_billing_phone' ) ? $order->get_billing_phone() : $order->billing_phone,
            'txEmailContact' => method_exists( $order, 'get_billing_email' ) ? $order->get_billing_email() : $order->billing_email,
            'txInstruction' => (string)substr( ( method_exists( $order, 'get_customer_note' ) ? $order->get_customer_note() : $order->customer_note ), 0, 63 )
        );
        
    }

    
    $payment_method = method_exists( $order, 'get_payment_method' ) ? $order->get_payment_method() : $order->payment_method;

    if ( $payment_method == 'cod' || in_array( $payment_method, get_option( 'furgefutar_fizetesi_modok' ) ) ) {				
        
        $PACKAGE = array(
            array(
                'idOrder' => (string)$order_id,
                'ctPackage' => '1',
                'amContent' => (string)$order->get_total(),
                
            )
        );
        
        $cod = 'true';
    
    }
    else{
        
        $PACKAGE = array(
            array(
                'idOrder' => (string)$order_id,
                'ctPackage' => '1',
            )
        );
        
        $cod = 'false';
        
    }


    $PACKAGES = array(
        'PACKAGE' => $PACKAGE
    );
    
    if( get_option( 'furgefutar_felado_neve' ) != '' && get_option( 'furgefutar_felado_bank_neve' ) != '' && get_option( 'furgefutar_felado_bankszamlaszama' ) != '' ){
        $ORDER = array(
            'flCOD'  => $cod,
            'nmRecipientCOD'  => get_option( 'furgefutar_felado_neve' ),
            'nmBankCOD'  => get_option( 'furgefutar_felado_bank_neve' ),
            'txBankAccountNumberCOD'  => get_option( 'furgefutar_felado_bankszamlaszama' ),
            'flNothingProhibited'  => furgefutar_konvertalas( get_option( 'furgefutar_tiltott_aru' ) ),
            'flAgreedToTermsAndConditions'  => furgefutar_konvertalas( get_option( 'furgefutar_aszf' ) ),
            'DESTINATIONADDRESS' => $DESTINATIONADDRESS,
            "PACKAGES" => $PACKAGES
        );
    }
    else{
        $ORDER = array(
            'flCOD'  => $cod,
            'flNothingProhibited'  => furgefutar_konvertalas( get_option( 'furgefutar_tiltott_aru' ) ),
            'flAgreedToTermsAndConditions'  => furgefutar_konvertalas( get_option( 'furgefutar_aszf' ) ),
            'DESTINATIONADDRESS' => $DESTINATIONADDRESS,
            "PACKAGES" => $PACKAGES
        );
    }

    $REQUEST = array(
        'flDebug' => furgefutar_konvertalas( get_option( 'furgefutar_tesztkornyezet' ) ),
        'cdLang' => furgefutar_nyelv(),
        'txEmail' => get_option( 'furgefutar_email' ),
        'txPassword' => get_option( 'furgefutar_jelszo' ),
        'ORDER' => $ORDER
    );

    
    $JSON = array(
        'REQUEST' => $REQUEST,
    );
    
    $furgefutar_megrendeles_return = array();
    
    $url = 'https://api.pactic.com/webservices/webshop2.ashx';

    if( extension_loaded( 'curl' ) ){

        $ch = curl_init();
        
        curl_setopt( $ch, CURLOPT_AUTOREFERER, TRUE );
        curl_setopt( $ch, CURLOPT_HEADER, FALSE );
        curl_setopt( $ch, CURLOPT_RETURNTRANSFER, TRUE );
        curl_setopt( $ch, CURLOPT_URL, $url );
        curl_setopt( $ch, CURLOPT_FOLLOWLOCATION, TRUE );    
        curl_setopt( $ch, CURLOPT_POSTFIELDS, json_encode( $JSON ) );
        curl_setopt( $ch, CURLOPT_HTTPHEADER, array( 'Content-Type: application/json' ) );   
        
        $furgefutar_megrendeles_json = curl_exec( $ch );
        
        curl_close($ch);
    
    }
    else if( ini_get( 'allow_url_fopen' ) ){

        $options = array(
            'http' => array(
                'header' => 'Content-Type: application/x-www-form-urlencoded',
                'method'  => 'POST',
                'content' => json_encode( $JSON ) 
            )
        );

        $context  = stream_context_create( $options );
        
        $furgefutar_megrendeles_json = file_get_contents( $url, false, $context );
    
    }
    

    $furgefutar_megrendeles = json_decode( $furgefutar_megrendeles_json, true);
    
    if( get_option( 'furgefutar_debug' ) == 'yes' ){

        $furgefutar_megrendeles_return['debug'] = '<strong>'.__( 'A Pactic rendszerének küldött kérés:', 'furgefutar' ).'</strong><pre>'.json_encode( $JSON, JSON_PRETTY_PRINT ).'</pre><strong>'.__( 'A Pactic rendszerétől kapott válasz:', 'furgefutar' ).'</strong><pre>'.json_encode( $furgefutar_megrendeles, JSON_PRETTY_PRINT ).'</pre>';
    }
    
	if ( $furgefutar_megrendeles_json == null ) {
		$furgefutar_megrendeles_return['hiba'][] = '<strong>'.__( 'Pactic hibaüzenet:', 'furgefutar' ).'</strong> '.'NULL response';
	}
	
	if ( $furgefutar_megrendeles == null ) {
	   
        $furgefutar_megrendeles_return['sikertelen'] = '<strong>'.__( 'Sikertelen Pactic megrendelés.', 'furgefutar' ).'</strong> '.__( 'Webshop rendelési azonosító:', 'furgefutar' ).' '.$order_id.' '.__( 'A kérésre nem érkezett válasz a Pactic rendszerétől.', 'furgefutar' ) .' '. __('Esetlegesen nem megfelelő jelszó vagy e-mal cím!', 'furgefutar' );

        $furgefutar_megrendeles_return['hiba'][] = '<strong>'.__( 'Pactic hibaüzenet:', 'furgefutar' ).'</strong> '.$furgefutar_megrendeles_json;

        $order->add_order_note( '<strong>'.__( 'Pactic hibaüzenet:', 'furgefutar' ).'</strong> '.__( 'A kérésre nem érkezett válasz a Pactic rendszerétől.', 'furgefutar' ) );   
        
	}
    else if( $furgefutar_megrendeles ){
        
        if( get_option( 'furgefutar_tesztkornyezet' ) == 'yes' ){
            
            //TESZT

            if( $furgefutar_megrendeles['Messages'] ){
                
                foreach( $furgefutar_megrendeles['Messages'] as $message ){
                    
                    if( $message['Text'] != 'TEST: Quote added successfully' ){
                                                
                        $furgefutar_megrendeles_return['hiba'][] = '<strong>'.__( 'Pactic rendszer hibaüzenet:', 'furgefutar' ).'</strong> '.$message['Text'];
                        
                    }
                    
                }
            
            }
            
            if( !empty( $furgefutar_megrendeles['Order']['Labels'] ) && !empty( $furgefutar_megrendeles['Order']['WayBills'] ) ){
                
                update_post_meta( $order_id, '_furgefutar_azonosito', 'teszt_'.$order_id );
                update_post_meta( $order_id, '_furgefutar_fuvarlevelszam', $furgefutar_megrendeles['Order']['WayBills'][0] );
                
                $minta_fuvarlevel = FURGEFUTAR_PLUGIN_DIR_URL.'/files/minta_fuvarlevel.pdf';
                
                $upload_dir = wp_upload_dir();
                
                $fajlnev_dir = $upload_dir['basedir'].'/furgefutar/fuvarlevel_'.$order_id.'_'.$furgefutar_megrendeles['Order']['WayBills'][0].'.pdf';

                copy( $minta_fuvarlevel, $fajlnev_dir);

                $furgefutar_megrendeles_return['sikeres'] = '<strong>'.__( 'Sikeres Pactic megrendelés.', 'furgefutar' ).'</strong> '.__( 'Webshop rendelési azonosító:', 'furgefutar' ).' '.$order_id.'. '.__( 'Pactic rendelési azonosító:', 'furgefutar' ).' '.$furgefutar_megrendeles['Order']['ID'].'. '.__( 'Fuvarlevélszám:', 'furgefutar' ).' '.$furgefutar_megrendeles['Order']['WayBills'][0].'. <em>'.__( 'Teszt üzemmódban a fuvarlevél valótlan adatokat tartalmaz!', 'furgefutar' ).'</em>';
                
                $order->add_order_note( 
                    sprintf( 
						__( 'Sikeres Pactic megrendelés. Pactic rendelési azonosító: %s. Fuvarlevélszám: %s. <em>Teszt üzemmódban a fuvarlevél valótlan adatokat tartalmaz!</em>', 'furgefutar' ),
                        $furgefutar_megrendeles['Order']['ID'], 
                        $furgefutar_megrendeles['Order']['WayBills'][0]
                    )
                );
  
                
            }
            else{
                
                $furgefutar_megrendeles_return['sikertelen'] = '<strong>'.__( 'Sikertelen Pactic megrendelés.', 'furgefutar' ).'</strong> '.__( 'Webshop rendelési azonosító:', 'furgefutar' ).' '.$order_id;
                
                $order->add_order_note( __( 'Sikertelen Pactic megrendelés.', 'furgefutar' ) );
                
            }
            
        }
        else{
            
            //ÉLES
            
            if( $furgefutar_megrendeles['Messages'] ){
                    
                foreach( $furgefutar_megrendeles['Messages'] as $message ){
                    
                    $furgefutar_megrendeles_return['hiba'][] = '<strong>'.__( 'Pactic hibaüzenet:', 'furgefutar' ).'</strong> '.$message['Text'];

                }
            
            }
            
            // van idQuote, nincs Waybill szám, nincs PDF
			if( $furgefutar_megrendeles['Order']['ID'] > 0 && empty( $furgefutar_megrendeles['Order']['Labels'] ) && empty( $furgefutar_megrendeles['Order']['WayBills'] ) ){
            
                update_post_meta( $order_id, '_furgefutar_azonosito', $furgefutar_megrendeles['Order']['ID'] );
                update_post_meta( $order_id, '_furgefutar_fuvarlevelszam', '' );
                
                $furgefutar_megrendeles_return['sikeres'] = '<strong>'.__( 'Sikeres Pactic megrendelés, azonban címke és fuvarlevél nem készült.', 'furgefutar' ).'</strong> '.__( 'A Pactic ügyfélszolgálata javítja a hibát és elküldi Önnek.', 'furgefutar' ).' '.__('Webshop rendelési azonosító:', 'furgefutar' ).' '.$order_id.'. '.__( 'Pactic rendelési azonosító:', 'furgefutar' ).' '.$furgefutar_megrendeles['Order']['ID'].'.';                        
 
                $order->add_order_note( __( 'Sikeres Pactic megrendelés, azonban címke és fuvarlevél nem készült. A Pactic ügyfélszolgálata javítja a hibát és elküldi Önnek.', 'furgefutar' ));
            
            }
			// van idQuote, van Waybill szám, de nincs PDF
            else if( $furgefutar_megrendeles['Order']['ID'] > 0 && empty( $furgefutar_megrendeles['Order']['Labels'] ) && !empty( $furgefutar_megrendeles['Order']['WayBills'] ) ){
            
                update_post_meta( $order_id, '_furgefutar_azonosito', $furgefutar_megrendeles['Order']['ID'] );
                update_post_meta( $order_id, '_furgefutar_fuvarlevelszam', $furgefutar_megrendeles['Order']['WayBills'][0] );
                
                $furgefutar_megrendeles_return['sikeres'] = '<strong>'.__( 'Sikeres Pactic megrendelés.', 'furgefutar' ).'</strong>  '.__( 'Webshop rendelési azonosító:', 'furgefutar' ).' '.$order_id.'. '.
                                   __( 'Pactic rendelési azonosító:', 'furgefutar' ) . ' '.$furgefutar_megrendeles['Order']['ID'].'.  '.
                                   __( 'Fuvarlevélszám:', 'furgefutar' ).' '.$furgefutar_megrendeles['Order']['WayBills'][0].'.';

                $order->add_order_note( 
                    sprintf( 
							__( 'Sikeres Pactic megrendelés. Pactic rendelési azonosító: %s. Fuvarlevélszám: %s.', 'furgefutar' ),
                            $furgefutar_megrendeles['Order']['ID'], 
                            $furgefutar_megrendeles['Order']['WayBills'][0]
                    )
                );
                
            }
			// van idQuote, van Waybill szám, és van PDF is
            else if( !empty( $furgefutar_megrendeles['Order']['Labels'] ) && !empty( $furgefutar_megrendeles['Order']['WayBills'] ) && $furgefutar_megrendeles['Order']['ID'] > 0 ){

                $fuvarlevel = $furgefutar_megrendeles['Order']['Labels'][0];
                
                if( !empty( $fuvarlevel ) ){
                    
                    update_post_meta( $order_id, '_furgefutar_azonosito', $furgefutar_megrendeles['Order']['ID'] );
                    update_post_meta( $order_id, '_furgefutar_fuvarlevelszam', $furgefutar_megrendeles['Order']['WayBills'][0] );
                    
                    $upload_dir = wp_upload_dir();
                    
                    $fuvarlevel = base64_decode($fuvarlevel);
                    
                    $fajlnev_dir = $upload_dir['basedir'].'/furgefutar/fuvarlevel_'.$order_id.'_'.$furgefutar_megrendeles['Order']['WayBills'][0].'.pdf';

                    file_put_contents( $fajlnev_dir, $fuvarlevel);
                    

                    $furgefutar_megrendeles_return['sikeres'] = '<strong>'.__( 'Sikeres Pactic megrendelés.', 'furgefutar' ).'</strong> '.__( 'Webshop rendelési azonosító:', 'furgefutar' ).' '.$order_id.'. '.
                                        __( 'Pactic rendelési azonosító:', 'furgefutar' ) . ' '.$furgefutar_megrendeles['Order']['ID'].'.  '.
                                        __( 'Fuvarlevélszám:', 'furgefutar' ).' '.$furgefutar_megrendeles['Order']['WayBills'][0].'.';

                    $order->add_order_note( 
                        sprintf( 
							__( 'Sikeres Pactic megrendelés. Pactic rendelési azonosító: %s. Fuvarlevélszám: %s.', 'furgefutar' ),
                            $furgefutar_megrendeles['Order']['ID'], 
                            $furgefutar_megrendeles['Order']['WayBills'][0]
                        )
                    );
                
                }
                else{
                
                    $furgefutar_megrendeles_return['sikertelen'] = '<strong>'.__( 'Sikertelen Pactic megrendelés.', 'furgefutar' ).'</strong> '.__( 'Webshop rendelési azonosító:', 'furgefutar' ).' '.$order_id;
                    
                    $order->add_order_note( __( 'Sikertelen Pactic megrendelés.', 'furgefutar' ) );
                    
                }
                
            }
            else{
                
                $furgefutar_megrendeles_return['sikertelen'] = '<strong>'.__( 'Sikertelen Pactic megrendelés.', 'furgefutar' ).'</strong> '.__( 'Webshop rendelési azonosító:', 'furgefutar' ).' '.$order_id;
                
                $order->add_order_note( __( 'Sikertelen Pactic megrendelés.', 'furgefutar' ) );
                
            }
            
        }
        
    }

    $furgefutar_megrendeles_return['furgefutar_gombok'] = furgefutar_gombok( $order_id, true );
           
    return json_encode( $furgefutar_megrendeles_return );

} 

/**********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/


add_filter( 'bulk_actions-edit-shop_order', 'furgefutar_bulk_actions' );
 
function furgefutar_bulk_actions( $bulk_array ) {
    
	$bulk_array['furgefutar_megrendeles'] = __( 'Pactic megrendelés', 'furgefutar' );
    $bulk_array['furgefutar_megrendeles_fuvarlevel_letoltes'] = __( 'Pactic megrendelés és fuvarlevél letöltés', 'furgefutar' );
	$bulk_array['furgefutar_fuvarlevel_letoltes'] = __( 'Pactic fuvarlevél letöltés', 'furgefutar' );
    
	return $bulk_array;

}

/**********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/

add_filter( 'handle_bulk_actions-edit-shop_order', 'furgefutar_bulk_action_handler', 10, 3 );
 
function furgefutar_bulk_action_handler( $redirect, $doaction, $order_ids ) {
 
	$redirect = remove_query_arg( array( 'furgefutar_megrendeles_kesz', 'furgefutar_fuvarlevel_letoltes_kesz', 'furgefutar_megrendeles_fuvarlevel_letoltes_kesz' ), $redirect );

	if ( $doaction == 'furgefutar_megrendeles' ) {

        $furgefutar_tomeges_megrendeles_return = furgefutar_tomeges_megrendeles( $order_ids );

		if( !session_id() ){
            session_start();
        }
        
        $_SESSION['furgefutar_tomeges_megrendeles_return'] = $furgefutar_tomeges_megrendeles_return;

        $redirect = add_query_arg(
			'furgefutar_megrendeles_kesz', 
			1,
		$redirect );
        
 
	}
    
    if ( $doaction == 'furgefutar_fuvarlevel_letoltes' ) {
        
        $furgefutar_fuvarlevel_letoltes_return = furgefutar_fuvarlevel_letoltes( $order_ids );
        
        if( !session_id() ){
            session_start();
        }
        
        $_SESSION['furgefutar_fuvarlevel_letoltes_return'] = $furgefutar_fuvarlevel_letoltes_return ;
        
        $redirect = add_query_arg(
			'furgefutar_fuvarlevel_letoltes_kesz', 
			1,
		$redirect );
        
	}
    
    if ( $doaction == 'furgefutar_megrendeles_fuvarlevel_letoltes' ) {
        
        $furgefutar_tomeges_megrendeles_return = furgefutar_tomeges_megrendeles( $order_ids );
        $furgefutar_fuvarlevel_letoltes_return = furgefutar_fuvarlevel_letoltes( $order_ids );

		if( !session_id() ){
            session_start();
        }
        
        $_SESSION['furgefutar_tomeges_megrendeles_return'] = $furgefutar_tomeges_megrendeles_return;
        
        $_SESSION['furgefutar_fuvarlevel_letoltes_return'] = $furgefutar_fuvarlevel_letoltes_return;
        
        $redirect = add_query_arg(
			'furgefutar_megrendeles_fuvarlevel_letoltes_kesz', 
			1,
		$redirect );
        
    }
    
    

 
	return $redirect;
 
}

/**********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/


add_action( 'admin_notices', 'furgefutar_bulk_action_notices' );
 
function furgefutar_bulk_action_notices() {
     
	if( !empty( $_REQUEST['furgefutar_megrendeles_kesz'] ) || !empty( $_REQUEST['furgefutar_megrendeles_fuvarlevel_letoltes_kesz'] ) ) {
        
        if( !session_id() ){
            session_start();
        }
        
        if( isset( $_SESSION['furgefutar_tomeges_megrendeles_return'] )  ){
            
            foreach( json_decode( $_SESSION['furgefutar_tomeges_megrendeles_return'], true ) as $order_id => $megrendeles_adatok ){
            
                if( isset( $megrendeles_adatok['sikeres'] ) ){
                    
                    $uzenet = $megrendeles_adatok['sikeres'];
                    
                    if( isset( $megrendeles_adatok['hiba'] ) ){
                        
                        $uzenet .= '<br/>';
                        
                        krsort( $megrendeles_adatok['hiba'] );
                        
                        foreach( $megrendeles_adatok['hiba'] as $hiba_id => $hiba_tartalom ){
 
                            $uzenet .= '<br/>'.$hiba_tartalom;
                            
                        }
  
                    }
                    
                    if( isset( $megrendeles_adatok['debug'] ) ){
                        
                        $uzenet .= '<br/><br/>';
                        
                        $uzenet .= $megrendeles_adatok['debug'];
                        
                    }
                    
                    echo '<div class="updated notice is-dismissible furgefutar_notice"><div><img src="'.FURGEFUTAR_PLUGIN_DIR_URL.'images/pactic_ikon_3.png" />'.$uzenet.'</div></div>';
   
                }
                else if( isset( $megrendeles_adatok['sikertelen'] ) ){
                    
                    $uzenet = $megrendeles_adatok['sikertelen'];
                    
                    if( isset( $megrendeles_adatok['hiba'] ) ){
                        
                        $uzenet .= '<br/>';
                        
                        krsort( $megrendeles_adatok['hiba'] );
                        
                        foreach( $megrendeles_adatok['hiba'] as $hiba_id => $hiba_tartalom ){
 
                            $uzenet .= '<br/>'.$hiba_tartalom;
                            
                        }
  
                    }
                    
                    if( isset( $megrendeles_adatok['debug'] ) ){
                        
                        $uzenet .= '<br/><br/>';
                        
                        $uzenet .= $megrendeles_adatok['debug'];
                        
                    }
                    
                    echo '<div class="error notice is-dismissible furgefutar_notice"><div><img src="'.FURGEFUTAR_PLUGIN_DIR_URL.'images/pactic_ikon_3.png" />'.$uzenet.'</div></div>';
   
                }
                else{
                    
                    $uzenet = '';
                    
                    if( isset( $megrendeles_adatok['hiba'] ) ){
                        
                        $uzenet .= '<br/>';
                        
                        krsort( $megrendeles_adatok['hiba'] );
                        
                        foreach( $megrendeles_adatok['hiba'] as $hiba_id => $hiba_tartalom ){
 
                            $uzenet .= '<br/>'.$hiba_tartalom;
                            
                        }
  
                    }
                    
                    if( isset( $megrendeles_adatok['debug'] ) ){
                        
                        $uzenet .= '<br/><br/>';
                        
                        $uzenet .= $megrendeles_adatok['debug'];
                        
                    }
                    
                    echo '<div class="error notice is-dismissible furgefutar_notice"><div><img src="'.FURGEFUTAR_PLUGIN_DIR_URL.'images/pactic_ikon_3.png" />'.$uzenet.'</div></div>';
   
                }
                
            }

            unset( $_SESSION['furgefutar_tomeges_megrendeles_return'] );
                        
        }
 
	}
    
    if( !empty( $_REQUEST['furgefutar_fuvarlevel_letoltes_kesz'] ) || !empty( $_REQUEST['furgefutar_megrendeles_fuvarlevel_letoltes_kesz'] ) ) {
        
        if( !session_id() ){
            session_start();
        }
        
        if( isset( $_SESSION['furgefutar_fuvarlevel_letoltes_return'] ) ){
            
            if( isset( $_SESSION['furgefutar_fuvarlevel_letoltes_return']['sikeres'] ) ){
                
                echo '<div class="updated notice is-dismissible furgefutar_notice"><div><img src="'.FURGEFUTAR_PLUGIN_DIR_URL.'images/pactic_ikon_3.png" />'.$_SESSION['furgefutar_fuvarlevel_letoltes_return']['sikeres'].'</div></div>';

            }
            else if( isset( $_SESSION['furgefutar_fuvarlevel_letoltes_return']['sikertelen'] ) ){
            
                echo '<div class="error notice is-dismissible furgefutar_notice"><div><img src="'.FURGEFUTAR_PLUGIN_DIR_URL.'images/pactic_ikon_3.png" />'.$_SESSION['furgefutar_fuvarlevel_letoltes_return']['sikertelen'].'</div></div>';

            }
            
            
        }
        
        unset( $_SESSION['furgefutar_fuvarlevel_letoltes_return'] );
        
    }
    
    
     
}

/**********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/

function furgefutar_tomeges_megrendeles( $order_ids ) {
    
    $furgefutar_megrendeles_return = array();
    
    foreach ( $order_ids as $order_id ) {
        
        $furgefutar_megrendeles_return[$order_id] = json_decode( furgefutar_megrendeles( $order_id ) );
        
    }    
    
    return json_encode( $furgefutar_megrendeles_return );

}

/**********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/

function furgefutar_fuvarlevel_letoltes( $order_ids ) {
    
    $furgefutar_fuvarlevel_letoltes_return = array();
    
    if( !empty( $order_ids ) ){
        
        require_once( 'tcpdf/tcpdf.php' );
        require_once( 'FPDI/fpdi.php' );
    	require_once( 'mergepdf.php' );
        
        $upload_dir = wp_upload_dir();
        
        $pdf_fajlok = array();
        
        $letezo_fuvarlevel = array();
        $nem_letezo_fuvarlevel = array();
        
    
        foreach ( $order_ids as $order_id ) {
    		
            $furgefutar_fuvarlevelszam = get_post_meta( $order_id, '_furgefutar_fuvarlevelszam', true );
            
            if( !empty( $furgefutar_fuvarlevelszam ) ){
                       
                if( file_exists( $upload_dir['basedir'].'/furgefutar/fuvarlevel_'.$order_id.'_'.$furgefutar_fuvarlevelszam.'.pdf' ) ){
                    
                    $letezo_fuvarlevel[$order_id] = $order_id;
    
                    $pdf_fajlok[$order_id] = $upload_dir['basedir'].'/furgefutar/fuvarlevel_'.$order_id.'_'.$furgefutar_fuvarlevelszam.'.pdf';
                    
                }
                else{
                    
                    $nem_letezo_fuvarlevel[$order_id] = $order_id;
                    
                }
            
            }
            else{
                    
                $nem_letezo_fuvarlevel[$order_id] = $order_id;
                
            }
            
    	}
        
        $fajlnev = 'fuvarlevelek_'.strtotime( date( 'Y-m-d H:i:s' ) ).'.pdf';
            
        $fajlnev_dir = $upload_dir['basedir'].'/furgefutar/'.$fajlnev;
        $fajlnev_url = $upload_dir['baseurl'].'/furgefutar/'.$fajlnev;
        
        if( file_exists( $fajlnev_dir ) ){
            
            unlink( $fajlnev_dir );
            
        }
    
        if( !empty( $pdf_fajlok ) ){
 
            MergePdf::merge( $pdf_fajlok, 'F', $fajlnev_dir );
            
            if( file_exists( $fajlnev_dir ) ){
    
                if( !empty( $nem_letezo_fuvarlevel ) ){
                    
                    $furgefutar_fuvarlevel_letoltes_return['sikeres'] = 
                        '<strong>'.__( 'Sikeres Pactic fuvarlevel generálás.', 'furgefutar' ).'</strong> '.
                        '<a class="button fuvarlevel_letoltes" href="'.$fajlnev_url.'" download="'.$fajlnev.'" >'.__( 'Fuvarlevél letöltése', 'furgefutar' ).'</a><br/><br/>'.
                        '<strong>'.__( 'A következő rendelések fuvarlevelét tartalmazza:', 'furgefutar' ).'</strong> '.implode(', ', $letezo_fuvarlevel).'<br/><br/>'.
                        '<strong>'.__( 'A következő rendelések fuvarlevelét nem tartalmazza:', 'furgefutar' ).'</strong> '.implode(', ', $nem_letezo_fuvarlevel);
                }
                else{
                    
                    $furgefutar_fuvarlevel_letoltes_return['sikeres'] = 
                        '<strong>'.__( 'Sikeres Pactic fuvarlevel generálás.', 'furgefutar' ).'</strong> '.
                        '<a class="button fuvarlevel_letoltes" href="'.$fajlnev_url.'" download="'.$fajlnev.'" >'.__( 'Fuvarlevél letöltése', 'furgefutar' ).'</a><br/><br/>'.
                        '<strong>'.__( 'A következő rendelések fuvarlevelét tartalmazza:', 'furgefutar' ).'</strong> '.implode(', ', $letezo_fuvarlevel);
     
                }
                
            }       
    
        }
        else{
            
            $furgefutar_fuvarlevel_letoltes_return['sikertelen'] = 
                '<strong>'.__( 'Sikertelen Pactic fuvarlevel generálás.', 'furgefutar' ).'</strong><br/><br/>'.
                '<strong>'.__( 'Egy kiválasztott rendelés sem tartalmaz fuvarlevelet!', 'furgefutar' ).'</strong> '.
                ''.__( 'Webshop rendelési azonosítók:', 'furgefutar' ).' '.implode(', ', $nem_letezo_fuvarlevel);
                
        }
        
    }
    
    
    return $furgefutar_fuvarlevel_letoltes_return;

}

/**********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/

function furgefutar_engedelyezett_fizetesi_modok( $filter = '' ){
    
    $fizetesi_modok = WC()->payment_gateways->payment_gateways();

    $furgefutar_engedelyezett_fizetesi_modok = array();

    foreach ( $fizetesi_modok as $fizetesi_mod ) {
        
        if( $filter != '' && $fizetesi_mod->id == $filter ){
            
            return $fizetesi_mod->title;
            
        }
        
        if( $fizetesi_mod->id != 'cod' ){
		
            if( $fizetesi_mod->enabled == 'yes' ){
                $furgefutar_engedelyezett_fizetesi_modok[ $fizetesi_mod->id ] = $fizetesi_mod->title.' ('.__( 'Engedélyezett', 'furgefutar' ).')';
            }
            else{
                $furgefutar_engedelyezett_fizetesi_modok[ $fizetesi_mod->id ] = $fizetesi_mod->title.' ('.__( 'Nem engedélyezett', 'furgefutar' ).')';
            }
            
        
        }
	
    }
    
	return $furgefutar_engedelyezett_fizetesi_modok;
  
}

/**********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/

function furgefutar_csomag_statusz( $furgefutar_fuvarlevelszam, $osszes = false ) {

    $url = 'http://api.pactic.com/webservices/shipment/tracking/track.ashx?waybill='.$furgefutar_fuvarlevelszam;
    
    if( extension_loaded( 'curl' ) ){

        $ch = curl_init();
    
        curl_setopt( $ch, CURLOPT_AUTOREFERER, TRUE );
        curl_setopt( $ch, CURLOPT_HEADER, FALSE );
        curl_setopt( $ch, CURLOPT_RETURNTRANSFER, TRUE );
        curl_setopt( $ch, CURLOPT_URL, $url );
        curl_setopt( $ch, CURLOPT_FOLLOWLOCATION, TRUE );    
        curl_setopt( $ch, CURLOPT_HTTPHEADER, array( 'Content-Type: application/json' ) );   
        
        $furgefutar_csomag_statusz_json = curl_exec( $ch );
        
        curl_close($ch);

    }
    else if( ini_get( 'allow_url_fopen' ) ){
       
        $furgefutar_csomag_statusz_json = file_get_contents( $url, false );
    
    }
    
    $furgefutar_csomag_statusz = json_decode( $furgefutar_csomag_statusz_json, true);
    
    
    $csomag_statusz_nevek = array(
        1 => array(
            'nev' => __( 'Adat fogadva', 'furgefutar' ),
            'leiras' => __( 'Kiszállításra adat átadva', 'furgefutar' ),
        ),
        2 => array(
            'nev' => __( 'Úton', 'furgefutar' ),
            'leiras' => __( 'Csomag úton van. Ez jelentheti azt, hogy a csomag a raktárba került, vagy a felvételt követően úton van a raktárba.', 'furgefutar' ),
        ),
        3 => array(
            'nev' => __( 'Kiszállítás alatt', 'furgefutar' ),
            'leiras' => __( 'A csomag a futárszolgálathoz került. Kiszállítás hamarosan várható', 'furgefutar' ),
        ),
        4 => array(
            'nev' => __( 'Kézbesítve', 'furgefutar' ),
            'leiras' => __( 'Sikeres kiszállítás, a csomagot átvették', 'furgefutar' ),
        ),
        5 => array(
            'nev' => __( 'Fennakadás ', 'furgefutar' ),
            'leiras' => __( 'A csomag kiszállítása során fennakadás történt (késés, rossz cím stb.) További információért keresse a Pactic-t', 'furgefutar' ),
        ),
        6 => array(
            'nev' => __( 'Visszaküldve', 'furgefutar' ),
            'leiras' => __( 'Csomag a feladóhoz visszaküldve', 'furgefutar' ),
        ),
        7 => array(
            'nev' => __( 'Törölt', 'furgefutar' ),
            'leiras' => __( 'A csomag törölve.', 'furgefutar' ),
        ),
        8 => array(
            'nev' => __( 'Nincs adat', 'furgefutar' ),
            'leiras' => __( 'A csomagról küldött információk nem ismertek. (Ez jelentheti azt, hogy az adatok ismertek, de nem megjeleníthető a weboldalon)', 'furgefutar' ),
        ),
        9 => array(
            'nev' => __( 'Sérült', 'furgefutar' ),
            'leiras' => __( 'A csomag megsérült.', 'furgefutar' ),
        ),
        10 => array(
            'nev' => __( 'Csomagpont', 'furgefutar' ),
            'leiras' => __( 'A csomag a csomagpontba került.', 'furgefutar' ),
        ),
        11 => array(
            'nev' => __( 'Eltűnt', 'furgefutar' ),
            'leiras' => __( 'A csomag eltűnt.', 'furgefutar' ),
        ),
        12 => array(
            'nev' => __( 'Elutasítva', 'furgefutar' ),
            'leiras' => __( 'A címzett megtagadta az átvételt', 'furgefutar' ),
        ),
        13 => array(
            'nev' => __( 'Címzett nem található', 'furgefutar' ),
            'leiras' => __( 'A címzett nem tartózkodott a megadott kiszállítási címen', 'furgefutar' ),
        )
    );
    
    
    $csomag_statusz_nevek = array(
        1 => array(             
            'nev' => __( 'Adat fogadva', 'furgefutar' ),             
            'leiras' => __( 'Kiszállításra adat átadva', 'furgefutar' ),         
        ),
        2 => array(             
            'nev' => __( 'Úton', 'furgefutar' ),             
            'leiras' => __( 'Csomag úton van. Ez jelentheti azt, hogy a csomag a raktárba került, vagy a felvételt követően úton van a raktárba.', 'furgefutar' ),         
        ),
        3 => array(             
            'nev' => __( 'Kiszállítás alatt', 'furgefutar' ),             
            'leiras' => __( 'A csomag a futárszolgálathoz került. Kiszállítás hamarosan várható', 'furgefutar' ),         
        ),
        4 => array(             
            'nev' => __( 'Kiszállítva', 'furgefutar' ),             
            'leiras' => __( 'Sikeres kiszállítás, a csomagot átvették', 'furgefutar' ),         
        ),
        5 => array(             
            'nev' => __( 'Fennakadás', 'furgefutar' ),             
            'leiras' => __( 'A csomag kiszállítása során fennakadás történt (késés, rossz cím stb.) További információért keresse a Pactic-t', 'furgefutar' ),         
        ),
        6 => array(             
            'nev' => __( 'Visszaküldve', 'furgefutar' ),             
            'leiras' => __( 'Csomag a feladóhoz visszaküldve', 'furgefutar' ),         
        ),
        7 => array(             
            'nev' => __( 'Törölve', 'furgefutar' ),             
            'leiras' => __( 'A csomag törölve.', 'furgefutar' ),        
        ),
        8 => array(             
            'nev' => __( 'Nincs adat', 'furgefutar' ),             
            'leiras' => __( 'A csomagról küldött információk nem ismertek. (Ez jelentheti azt, hogy az adatok ismertek, de nem megjeleníthető a weboldalon)', 'furgefutar' ),         
        ),
        9 => array(             
            'nev' => __( 'Sérülés', 'furgefutar' ),             
            'leiras' => __( 'A csomag megsérült.', 'furgefutar' ),         
        ),
        10 => array(             
            'nev' => __( 'Csomagponton', 'furgefutar' ),             
            'leiras' => __( 'A csomag a csomagpontba került.', 'furgefutar' ),         
        ),
        11 => array(             
            'nev' => __( 'Eltűnt', 'furgefutar' ),             
            'leiras' => __( 'A csomag eltűnt.', 'furgefutar' ),         
        ),
        12 => array(             
            'nev' => __( 'Elutasítva', 'furgefutar' ),             
            'leiras' => __( 'A címzett megtagadta az átvételt', 'furgefutar' ),         
        ),
        13 => array(             
            'nev' => __( 'Címzett nem elérhető', 'furgefutar' ),             
            'leiras' => __( 'A címzett nem tartózkodott a megadott kiszállítási címen', 'furgefutar' ),         
        ),
        14 => array(             
            'nev' => __( 'Hibás cím', 'furgefutar' ),             
            'leiras' => '',         
        ),
        15 => array(             
            'nev' => __( 'HUB betárolva', 'furgefutar' ),             
            'leiras' => '',         
        ),
        16 => array(             
            'nev' => __( 'Kiszállítási idő módosítva', 'furgefutar' ),             
            'leiras' => '',         
        ),
        17 => array(             
            'nev' => __( 'Félreszortírozva, Késés', 'furgefutar' ),             
            'leiras' => '',         
        ),
        18 => array(             
        'nev' => __( 'Kézbesíthetetlen - sofőr kifutott az időből', 'furgefutar' ),             
            'leiras' => '',         
        ),
        19 => array(             
            'nev' => __( 'Pénzhiány', 'furgefutar' ),             
            'leiras' => '',         
        ),
        20 => array(             
            'nev' => __( 'Kézbesíthetetlen - akadály (pl. társasház ajtó zárva, elkülönített épület)', 'furgefutar' ),             
            'leiras' => '',         
        ),
        21 => array(             
            'nev' => __( 'Kézbesíthetetlen', 'furgefutar' ),             
            'leiras' => '',         
        ),
        22 => array(             
            'nev' => __( 'Túlméretes csomag', 'furgefutar' ),             
            'leiras' => '',         
        ),
        23 => array(             
            'nev' => __( 'Címmódosítás', 'furgefutar' ),             
            'leiras' => '',         
        ),
        24 => array(            
            'nev' => __( 'Címzett értesítve', 'furgefutar' ),             
            'leiras' => '',         
        ),
        25 => array(             
            'nev' => __( 'Vámkezelés (szükség esetén értesítik a feladót/címzettet)', 'furgefutar' ),             
            'leiras' => '',         
        ),
        26 => array(             
            'nev' => __( 'Futár felvette a csomagot', 'furgefutar' ),             
            'leiras' => '',         
        ),
        27 => array(             
            'nev' => __( 'Szortírozó központban', 'furgefutar' ),             
            'leiras' => '',         
        ),
        101 => array(             
            'nev' => __( 'Konszolidálva', 'furgefutar' ),             
            'leiras' => '',         
        ),
        102 => array(             
            'nev' => __( 'Úton a szortírozóba', 'furgefutar' ),             
            'leiras' => '',         
        ),
        103 => array(             
            'nev' => __( 'Lerakva a szortírozóban', 'furgefutar' ),             
            'leiras' => '',         
        ),
        104 => array(             
            'nev' => __( 'Visszaküldve a feladóhoz', 'furgefutar' ),             
            'leiras' => '',         
        ),
        105 => array(            
            'nev' => __( 'Feladó összekészítette', 'furgefutar' ),             
            'leiras' => '',         
        ),
        106 => array(             
            'nev' => __( 'Konszolidálva RO raktárban', 'furgefutar' ),             
            'leiras' => '',         
        ),
        107 => array(             
            'nev' => __( 'Konszolidálva HU raktárban', 'furgefutar' ),             
            'leiras' => '',         
        ),
        108 => array(             
            'nev' => __( 'Konszolidálva HUB raktárban', 'furgefutar' ),             
            'leiras' => '',         
        ),
        109 => array(             
            'nev' => __( 'Konszolidálva HUB raktárban', 'furgefutar' ),             
            'leiras' => '',         
        ),
        110 => array(             
            'nev' => __( 'Visszáru megérkezett a Pactic raktárba', 'furgefutar' ),             
            'leiras' => '',         
        ),
        111 => array(             
            'nev' => __( 'Visszaküldve a feladóhoz', 'furgefutar' ),            
            'leiras' => '',         
        ),
        112 => array(             
            'nev' => __( 'Nem szabványos csomag elutasítás Pacticnél', 'furgefutar' ),             
            'leiras' => '',         
        ),
    );
    
    $csomag_statuszok = array();
    
    if( $furgefutar_csomag_statusz ){
        
        if( $furgefutar_csomag_statusz[0]['history'] ){
            
            foreach( $furgefutar_csomag_statusz[0]['history'] as $history ){
                
                if( array_key_exists( $history['status'], $csomag_statusz_nevek ) ){
                
                    $csomag_statuszok[] = array(
                        'id' => $history['status'],
                        'nev' => $csomag_statusz_nevek[$history['status']]['nev'],
                        'leiras' => $csomag_statusz_nevek[$history['status']]['leiras'],
                        'datum' => $history['date'],
                    );
                
                }
                
            }
            
        }
    
    }
    
    if( $osszes == false ){
        return end( $csomag_statuszok );
    }
    else{
        return $csomag_statuszok;
    }
    
}

/**********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/

function furgefutar_fuvarlevelek_ajax_torles() {
    
    $upload_dir = wp_upload_dir();
    
    $counter = 0;

    if ( isset($_REQUEST) ) {
                
        foreach ( glob( $upload_dir['basedir'].'/furgefutar/fuvarlevelek*.pdf' ) as $filename ) {

            unlink($filename);
            
            $counter++;
        }

    }
    
    echo $counter.' '.__( 'fájl törölve.', 'furgefutar' );
    
    die();
}

add_action( 'wp_ajax_furgefutar_fuvarlevelek_ajax_torles', 'furgefutar_fuvarlevelek_ajax_torles' );


/**********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/


add_action( 'admin_notices', 'furgefutar_kornyezet_ellenorzes' );
 
function furgefutar_kornyezet_ellenorzes() {
    
    if( !extension_loaded( 'curl' ) && !ini_get( 'allow_url_fopen' ) ){
        
        if(  get_option( 'furgefutar_allapot' ) == 'yes' ){
            
            update_option( 'furgefutar_allapot', 'no' );
            
        }
        
        echo '<div class="error notice is-dismissible furgefutar_notice">';
            echo '<div>';
                echo '<img src="'.FURGEFUTAR_PLUGIN_DIR_URL.'images/pactic_ikon_3.png" />';
                echo '<strong>';
                    echo __( 'Pactic hibaüzenet', 'furgefutar' );
                    echo '<br/><br/>';
                    echo __( 'A bővítmény használatához szükség van a Client URL Library telepítésére vagy az allow_url_fopen engedélyezésére. Kérem, jelezze ezt a weboldal üzemeltetőjének.', 'furgefutar' );
                echo '</strong>';
            echo '</div>';
            echo '<button type="button" class="notice-dismiss furgefutar_notice_dismiss"></button>';
        echo '</div>';

    }
 
}

/**********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/


add_action( 'admin_notices', 'furgefutar_utanvet_beallitas_ellenorzes' );
 
function furgefutar_utanvet_beallitas_ellenorzes() {

    if( get_option( 'furgefutar_allapot' ) == 'yes' && get_option( 'furgefutar_cod_notice_dismiss' ) != 'yes'  ){
    
        echo '<div class="furgefutar_warning notice notice-warning furgefutar_notice">';
            
            echo '<div>';
                
                echo '<img src="'.FURGEFUTAR_PLUGIN_DIR_URL.'images/pactic_ikon_3.png" />';
                
                echo '<strong>';
                    echo __( 'Pactic figyelmeztetés', 'furgefutar' );
                echo '</strong>';
     
                echo '<br/>';
                
                echo '<p>';
                    echo __( 'A bővítmény automatikusan kiválasztja az alapértelmezett utánvétes fizetési módot:', 'furgefutar' ).' <strong>'.furgefutar_engedelyezett_fizetesi_modok( 'cod' ).'</strong>.';
                echo '</p>';
                echo '<p>';
                    echo __( 'Amennyiben webáruházában további fizetési módok is utánvétesnek számítanak, ', 'furgefutar' );
                    echo ' <a href="'.admin_url().'admin.php?page=wc-settings&tab=furgefutar#furgefutar_fizetesi_modok">'.__( 'úgy itt állíthatja be azokat.', 'furgefutar' ).'</a>';
                
                echo '</p>'; 
                
                echo '<p>';  
                    echo '<button type="button" class="button button-secondary furgefutar_cod_notice_dismiss">'.__( 'Megértettem', 'furgefutar' ).'</button>';
                echo '</p>';  

            echo '</div>';
             
        echo '</div>';

    }

}

/**********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/

function furgefutar_cod_notice_dismiss() {

    if ( isset($_REQUEST) ) {
                
         update_option( 'furgefutar_cod_notice_dismiss', 'yes' );

    }

    die();
}

add_action( 'wp_ajax_furgefutar_cod_notice_dismiss', 'furgefutar_cod_notice_dismiss' );
     
/**********************************************************************************************************************************************************************/
/**********************************************************************************************************************************************************************/

   
?>